/*
 * Copyright (c) 2004, 2005  Nokia
 * Author:  Timo Savola <tsavola@movial.fi>
 *
 * sb_uclibc_wrapper is licensed under GPL.
 * You can read the full license at http://www.gnu.org/licenses/gpl.txt
 */

#ifndef _GNU_SOURCE
# define _GNU_SOURCE
#endif

#include "sb_config.hh"
#include <iostream>
#include <cstdlib>
#include <cstring>
#include <cerrno>
#include <unistd.h>

#define UCLIBC_PREFIX "arm-linux-uclibc-"
#define WRAPPER_PATH  "/scratchbox/compilers/bin/sb_gcc_wrapper"

using namespace std;

int main(int argc, char **argv)
{
	string name;

	map<string,string> config;
	sb::read_config(config);

	if (config["SBOX_DEFAULT_GCC_PREFIX"] == UCLIBC_PREFIX) {
		char *cmd = basename(argv[0]);
		char *str = strstr(cmd, "arm-linux-");
		if (str)
			cmd = str + 10;

		name = UCLIBC_PREFIX;
		name += cmd;

		argv[0] = const_cast<char *> (name.c_str());
	}

	execv(WRAPPER_PATH, argv);

	cerr << WRAPPER_PATH << ": " << strerror(errno) << endl;
	return 1;
}
